// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_FRAME_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_FRAME_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreInitializers();
}

namespace exotica
{

class FrameInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() {return "exotica/Frame" ;}

    FrameInitializer() : InitializerBase(),
        LinkOffset( Eigen::IdentityTransform()) ,
        Base( "") ,
        BaseOffset( Eigen::IdentityTransform()) 
    {
    }

    FrameInitializer( std::string _Link, Eigen::VectorXd _LinkOffset =  Eigen::IdentityTransform(), std::string _Base =  "", Eigen::VectorXd _BaseOffset =  Eigen::IdentityTransform()) : InitializerBase(),
        Link(_Link) ,
        LinkOffset(_LinkOffset) ,
        Base(_Base) ,
        BaseOffset(_BaseOffset) 
    {
    }

    FrameInitializer(const Initializer& other) : FrameInitializer()
    {
        if (other.HasProperty("Link")) {const Property& prop=other.properties_.at("Link"); if(prop.IsSet()) Link = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("LinkOffset")) {const Property& prop=other.properties_.at("LinkOffset"); if(prop.IsSet()) LinkOffset = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("Base")) {const Property& prop=other.properties_.at("Base"); if(prop.IsSet()) Base = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("BaseOffset")) {const Property& prop=other.properties_.at("BaseOffset"); if(prop.IsSet()) BaseOffset = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)FrameInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Link") || !other.properties_.at("Link").IsSet()) ThrowPretty("Initializer FrameInitializer requires property Link to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Link", Property("Link", true, boost::any(Link)));
        ret.properties_.emplace("LinkOffset", Property("LinkOffset", false, boost::any(LinkOffset)));
        ret.properties_.emplace("Base", Property("Base", false, boost::any(Base)));
        ret.properties_.emplace("BaseOffset", Property("BaseOffset", false, boost::any(BaseOffset)));
        return ret;
    }

    std::string Link;
    Eigen::VectorXd LinkOffset;
    std::string Base;
    Eigen::VectorXd BaseOffset;
};

}

#include<exotica_core/exotica_core_initializers_numerator.h>


#endif