// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_LINK_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_LINK_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreInitializers();
}

namespace exotica
{

class LinkInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() {return "exotica/Link" ;}

    LinkInitializer() : InitializerBase(),
        Transform( Eigen::IdentityTransform()) ,
        Parent( "") ,
        CenterOfMass( Eigen::IdentityTransform()) ,
        Mass( 0.0) 
    {
    }

    LinkInitializer( std::string _Name, Eigen::VectorXd _Transform =  Eigen::IdentityTransform(), std::string _Parent =  "", Eigen::VectorXd _CenterOfMass =  Eigen::IdentityTransform(), double _Mass =  0.0) : InitializerBase(),
        Name(_Name) ,
        Transform(_Transform) ,
        Parent(_Parent) ,
        CenterOfMass(_CenterOfMass) ,
        Mass(_Mass) 
    {
    }

    LinkInitializer(const Initializer& other) : LinkInitializer()
    {
        if (other.HasProperty("Name")) {const Property& prop=other.properties_.at("Name"); if(prop.IsSet()) Name = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("Transform")) {const Property& prop=other.properties_.at("Transform"); if(prop.IsSet()) Transform = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("Parent")) {const Property& prop=other.properties_.at("Parent"); if(prop.IsSet()) Parent = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("CenterOfMass")) {const Property& prop=other.properties_.at("CenterOfMass"); if(prop.IsSet()) CenterOfMass = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
        if (other.HasProperty("Mass")) {const Property& prop=other.properties_.at("Mass"); if(prop.IsSet()) Mass = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());}
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)LinkInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer LinkInitializer requires property Name to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("Transform", Property("Transform", false, boost::any(Transform)));
        ret.properties_.emplace("Parent", Property("Parent", false, boost::any(Parent)));
        ret.properties_.emplace("CenterOfMass", Property("CenterOfMass", false, boost::any(CenterOfMass)));
        ret.properties_.emplace("Mass", Property("Mass", false, boost::any(Mass)));
        return ret;
    }

    std::string Name;
    Eigen::VectorXd Transform;
    std::string Parent;
    Eigen::VectorXd CenterOfMass;
    double Mass;
};

}

#include<exotica_core/exotica_core_initializers_numerator.h>


#endif